"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.raceInit = exports.race = void 0;
var Observable_1 = require("../Observable");
var from_1 = require("./from");
var argsOrArgArray_1 = require("../util/argsOrArgArray");
var Subscriber_1 = require("../Subscriber");
function race() {
    var sources = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sources[_i] = arguments[_i];
    }
    sources = (0, argsOrArgArray_1.argsOrArgArray)(sources);
    return sources.length === 1 ? (0, from_1.from)(sources[0]) : new Observable_1.Observable(raceInit(sources));
}
exports.race = race;
function raceInit(sources) {
    return function (destination) {
        var subscriptions = [];
        var _loop_1 = function (i) {
            subscriptions.push((0, from_1.from)(sources[i]).subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    if (subscriptions) {
                        for (var s = 0; s < subscriptions.length; s++) {
                            s !== i && subscriptions[s].unsubscribe();
                        }
                        subscriptions = null;
                    }
                    destination.next(value);
                },
            })));
        };
        for (var i = 0; subscriptions && !destination.closed && i < sources.length; i++) {
            _loop_1(i);
        }
    };
}
exports.raceInit = raceInit;
//# sourceMappingURL=race.js.map