"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buffer = void 0;
var Observable_1 = require("../Observable");
var noop_1 = require("../util/noop");
var Subscriber_1 = require("../Subscriber");
var from_1 = require("../observable/from");
function buffer(closingNotifier) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var currentBuffer = [];
            (0, from_1.from)(closingNotifier).subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function () {
                    var b = currentBuffer;
                    currentBuffer = [];
                    destination.next(b);
                },
                complete: noop_1.noop,
            }));
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) { return currentBuffer.push(value); },
                complete: function () {
                    destination.next(currentBuffer);
                    destination.complete();
                },
            }));
            return function () {
                currentBuffer = null;
            };
        });
    };
}
exports.buffer = buffer;
//# sourceMappingURL=buffer.js.map