"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bufferWhen = void 0;
var Subscriber_1 = require("../Subscriber");
var Observable_1 = require("../Observable");
var noop_1 = require("../util/noop");
var from_1 = require("../observable/from");
function bufferWhen(closingSelector) {
    return function (source) {
        return new Observable_1.Observable(function (subscriber) {
            var buffer = null;
            var closingSubscriber = null;
            var openBuffer = function () {
                closingSubscriber === null || closingSubscriber === void 0 ? void 0 : closingSubscriber.unsubscribe();
                var b = buffer;
                buffer = [];
                b && subscriber.next(b);
                (0, from_1.from)(closingSelector()).subscribe((closingSubscriber = (0, Subscriber_1.operate)({
                    destination: subscriber,
                    next: openBuffer,
                    complete: noop_1.noop,
                })));
            };
            openBuffer();
            source.subscribe((0, Subscriber_1.operate)({
                destination: subscriber,
                next: function (value) { return buffer === null || buffer === void 0 ? void 0 : buffer.push(value); },
                complete: function () {
                    buffer && subscriber.next(buffer);
                    subscriber.complete();
                },
                finalize: function () { return (buffer = closingSubscriber = null); },
            }));
        });
    };
}
exports.bufferWhen = bufferWhen;
//# sourceMappingURL=bufferWhen.js.map