"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultIfEmpty = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function defaultIfEmpty(defaultValue) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var hasValue = false;
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    hasValue = true;
                    destination.next(value);
                },
                complete: function () {
                    if (!hasValue) {
                        destination.next(defaultValue);
                    }
                    destination.complete();
                },
            }));
        });
    };
}
exports.defaultIfEmpty = defaultIfEmpty;
//# sourceMappingURL=defaultIfEmpty.js.map