"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.endWith = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
var from_1 = require("../observable/from");
function endWith() {
    var values = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        values[_i] = arguments[_i];
    }
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                complete: function () {
                    (0, from_1.subscribeToArray)(values, destination);
                },
            }));
        });
    };
}
exports.endWith = endWith;
//# sourceMappingURL=endWith.js.map