"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.every = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function every(predicate, thisArg) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var index = 0;
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    if (!predicate.call(thisArg, value, index++, source)) {
                        destination.next(false);
                        destination.complete();
                    }
                },
                complete: function () {
                    destination.next(true);
                    destination.complete();
                },
            }));
        });
    };
}
exports.every = every;
//# sourceMappingURL=every.js.map