"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exhaustMap = void 0;
var Subscriber_1 = require("../Subscriber");
var from_1 = require("../observable/from");
var Observable_1 = require("../Observable");
function exhaustMap(project) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var index = 0;
            var innerSub = null;
            var isComplete = false;
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (outerValue) {
                    if (!innerSub) {
                        innerSub = (0, Subscriber_1.operate)({
                            destination: destination,
                            complete: function () {
                                innerSub = null;
                                isComplete && destination.complete();
                            },
                        });
                        (0, from_1.from)(project(outerValue, index++)).subscribe(innerSub);
                    }
                },
                complete: function () {
                    isComplete = true;
                    !innerSub && destination.complete();
                },
            }));
        });
    };
}
exports.exhaustMap = exhaustMap;
//# sourceMappingURL=exhaustMap.js.map