"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filter = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function filter(predicate, thisArg) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var index = 0;
            source.subscribe((0, Subscriber_1.operate)({ destination: destination, next: function (value) { return predicate.call(thisArg, value, index++) && destination.next(value); } }));
        });
    };
}
exports.filter = filter;
//# sourceMappingURL=filter.js.map