"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFind = exports.find = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function find(predicate) {
    return function (source) { return new Observable_1.Observable(function (subscriber) { return createFind(predicate, 'value', source, subscriber); }); };
}
exports.find = find;
function createFind(predicate, emit, source, destination) {
    var findIndex = emit === 'index';
    var index = 0;
    source.subscribe((0, Subscriber_1.operate)({
        destination: destination,
        next: function (value) {
            var i = index++;
            if (predicate(value, i, source)) {
                destination.next(findIndex ? i : value);
                destination.complete();
            }
        },
        complete: function () {
            destination.next(findIndex ? -1 : undefined);
            destination.complete();
        },
    }));
}
exports.createFind = createFind;
//# sourceMappingURL=find.js.map