"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.materialize = void 0;
var NotificationFactories_1 = require("../NotificationFactories");
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function materialize() {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    destination.next((0, NotificationFactories_1.nextNotification)(value));
                },
                error: function (error) {
                    destination.next((0, NotificationFactories_1.errorNotification)(error));
                    destination.complete();
                },
                complete: function () {
                    destination.next(NotificationFactories_1.COMPLETE_NOTIFICATION);
                    destination.complete();
                },
            }));
        });
    };
}
exports.materialize = materialize;
//# sourceMappingURL=materialize.js.map