"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.observeOn = void 0;
var executeSchedule_1 = require("../util/executeSchedule");
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function observeOn(scheduler, delay) {
    if (delay === void 0) { delay = 0; }
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) { return (0, executeSchedule_1.executeSchedule)(destination, scheduler, function () { return destination.next(value); }, delay); },
                error: function (err) { return (0, executeSchedule_1.executeSchedule)(destination, scheduler, function () { return destination.error(err); }, delay); },
                complete: function () { return (0, executeSchedule_1.executeSchedule)(destination, scheduler, function () { return destination.complete(); }, delay); },
            }));
        });
    };
}
exports.observeOn = observeOn;
//# sourceMappingURL=observeOn.js.map