"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pairwise = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function pairwise() {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var prev;
            var hasPrev = false;
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    var p = prev;
                    prev = value;
                    hasPrev && destination.next([p, value]);
                    hasPrev = true;
                },
            }));
        });
    };
}
exports.pairwise = pairwise;
//# sourceMappingURL=pairwise.js.map