"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.repeatWhen = void 0;
var Observable_1 = require("../Observable");
var from_1 = require("../observable/from");
var Subject_1 = require("../Subject");
var Subscriber_1 = require("../Subscriber");
function repeatWhen(notifier) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var innerSub;
            var syncResub = false;
            var completions$;
            var isNotifierComplete = false;
            var isMainComplete = false;
            var checkComplete = function () { return isMainComplete && isNotifierComplete && (destination.complete(), true); };
            var getCompletionSubject = function () {
                if (!completions$) {
                    completions$ = new Subject_1.Subject();
                    (0, from_1.from)(notifier(completions$)).subscribe((0, Subscriber_1.operate)({
                        destination: destination,
                        next: function () {
                            if (innerSub) {
                                subscribeForRepeatWhen();
                            }
                            else {
                                syncResub = true;
                            }
                        },
                        complete: function () {
                            isNotifierComplete = true;
                            checkComplete();
                        },
                    }));
                }
                return completions$;
            };
            var subscribeForRepeatWhen = function () {
                isMainComplete = false;
                innerSub = source.subscribe((0, Subscriber_1.operate)({
                    destination: destination,
                    complete: function () {
                        isMainComplete = true;
                        !checkComplete() && getCompletionSubject().next();
                    },
                }));
                if (syncResub) {
                    innerSub.unsubscribe();
                    innerSub = null;
                    syncResub = false;
                    subscribeForRepeatWhen();
                }
            };
            subscribeForRepeatWhen();
        });
    };
}
exports.repeatWhen = repeatWhen;
//# sourceMappingURL=repeatWhen.js.map