"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.retryWhen = void 0;
var Observable_1 = require("../Observable");
var from_1 = require("../observable/from");
var Subject_1 = require("../Subject");
var Subscriber_1 = require("../Subscriber");
function retryWhen(notifier) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var innerSub;
            var syncResub = false;
            var errors$;
            var subscribeForRetryWhen = function () {
                innerSub = source.subscribe((0, Subscriber_1.operate)({
                    destination: destination,
                    error: function (err) {
                        if (!errors$) {
                            errors$ = new Subject_1.Subject();
                            (0, from_1.from)(notifier(errors$)).subscribe((0, Subscriber_1.operate)({
                                destination: destination,
                                next: function () {
                                    return innerSub ? subscribeForRetryWhen() : (syncResub = true);
                                },
                            }));
                        }
                        if (errors$) {
                            errors$.next(err);
                        }
                    },
                }));
                if (syncResub) {
                    innerSub.unsubscribe();
                    innerSub = null;
                    syncResub = false;
                    subscribeForRetryWhen();
                }
            };
            subscribeForRetryWhen();
        });
    };
}
exports.retryWhen = retryWhen;
//# sourceMappingURL=retryWhen.js.map