"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sample = void 0;
var from_1 = require("../observable/from");
var Observable_1 = require("../Observable");
var noop_1 = require("../util/noop");
var Subscriber_1 = require("../Subscriber");
function sample(notifier) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var hasValue = false;
            var lastValue = null;
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    hasValue = true;
                    lastValue = value;
                },
            }));
            (0, from_1.from)(notifier).subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function () {
                    if (hasValue) {
                        hasValue = false;
                        var value = lastValue;
                        lastValue = null;
                        destination.next(value);
                    }
                },
                complete: noop_1.noop,
            }));
        });
    };
}
exports.sample = sample;
//# sourceMappingURL=sample.js.map