"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.scanInternals = void 0;
var Subscriber_1 = require("../Subscriber");
function scanInternals(accumulator, seed, hasSeed, emitOnNext, emitBeforeComplete, source, destination) {
    var hasState = hasSeed;
    var state = seed;
    var index = 0;
    source.subscribe((0, Subscriber_1.operate)({
        destination: destination,
        next: function (value) {
            var i = index++;
            state = hasState
                ?
                    accumulator(state, value, i)
                :
                    ((hasState = true), value);
            emitOnNext && destination.next(state);
        },
        complete: emitBeforeComplete
            ? function () {
                hasState && destination.next(state);
                destination.complete();
            }
            : undefined,
    }));
}
exports.scanInternals = scanInternals;
//# sourceMappingURL=scanInternals.js.map