"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.skipUntil = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
var from_1 = require("../observable/from");
var noop_1 = require("../util/noop");
function skipUntil(notifier) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var taking = false;
            var skipSubscriber = (0, Subscriber_1.operate)({
                destination: destination,
                next: function () {
                    skipSubscriber === null || skipSubscriber === void 0 ? void 0 : skipSubscriber.unsubscribe();
                    taking = true;
                },
                complete: noop_1.noop,
            });
            (0, from_1.from)(notifier).subscribe(skipSubscriber);
            source.subscribe((0, Subscriber_1.operate)({ destination: destination, next: function (value) { return taking && destination.next(value); } }));
        });
    };
}
exports.skipUntil = skipUntil;
//# sourceMappingURL=skipUntil.js.map