"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.skipWhile = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function skipWhile(predicate) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var taking = false;
            var index = 0;
            source.subscribe((0, Subscriber_1.operate)({ destination: destination, next: function (value) { return (taking || (taking = !predicate(value, index++))) && destination.next(value); } }));
        });
    };
}
exports.skipWhile = skipWhile;
//# sourceMappingURL=skipWhile.js.map