"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.switchMap = void 0;
var Subscriber_1 = require("../Subscriber");
var from_1 = require("../observable/from");
var Observable_1 = require("../Observable");
function switchMap(project) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var innerSubscriber = null;
            var index = 0;
            var isComplete = false;
            var checkComplete = function () { return isComplete && !innerSubscriber && destination.complete(); };
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    innerSubscriber === null || innerSubscriber === void 0 ? void 0 : innerSubscriber.unsubscribe();
                    var outerIndex = index++;
                    (0, from_1.from)(project(value, outerIndex)).subscribe((innerSubscriber = (0, Subscriber_1.operate)({
                        destination: destination,
                        complete: function () {
                            innerSubscriber = null;
                            checkComplete();
                        },
                    })));
                },
                complete: function () {
                    isComplete = true;
                    checkComplete();
                },
            }));
        });
    };
}
exports.switchMap = switchMap;
//# sourceMappingURL=switchMap.js.map