"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.switchScan = void 0;
var switchMap_1 = require("./switchMap");
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function switchScan(accumulator, seed) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var state = seed;
            (0, switchMap_1.switchMap)(function (value, index) { return accumulator(state, value, index); })(source).subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (innerValue) {
                    state = innerValue;
                    destination.next(innerValue);
                },
            }));
            return function () {
                state = null;
            };
        });
    };
}
exports.switchScan = switchScan;
//# sourceMappingURL=switchScan.js.map