"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.take = void 0;
var empty_1 = require("../observable/empty");
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function take(count) {
    return count <= 0
        ?
            function () { return empty_1.EMPTY; }
        : function (source) {
            return new Observable_1.Observable(function (destination) {
                var seen = 0;
                var operatorSubscriber = (0, Subscriber_1.operate)({
                    destination: destination,
                    next: function (value) {
                        if (++seen < count) {
                            destination.next(value);
                        }
                        else {
                            operatorSubscriber.unsubscribe();
                            destination.next(value);
                            destination.complete();
                        }
                    },
                });
                source.subscribe(operatorSubscriber);
            });
        };
}
exports.take = take;
//# sourceMappingURL=take.js.map