"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.takeLast = void 0;
var empty_1 = require("../observable/empty");
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function takeLast(count) {
    return count <= 0
        ? function () { return empty_1.EMPTY; }
        : function (source) {
            return new Observable_1.Observable(function (destination) {
                var ring = new Array(count);
                var counter = 0;
                source.subscribe((0, Subscriber_1.operate)({
                    destination: destination,
                    next: function (value) {
                        ring[counter++ % count] = value;
                    },
                    complete: function () {
                        var start = count <= counter ? counter : 0;
                        var total = Math.min(count, counter);
                        for (var n = 0; n < total; n++) {
                            destination.next(ring[(start + n) % count]);
                        }
                        destination.complete();
                    },
                    finalize: function () {
                        ring = null;
                    },
                }));
            });
        };
}
exports.takeLast = takeLast;
//# sourceMappingURL=takeLast.js.map