"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.takeUntil = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
var from_1 = require("../observable/from");
var noop_1 = require("../util/noop");
function takeUntil(notifier) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            (0, from_1.from)(notifier).subscribe((0, Subscriber_1.operate)({ destination: destination, next: function () { return destination.complete(); }, complete: noop_1.noop }));
            !destination.closed && source.subscribe(destination);
        });
    };
}
exports.takeUntil = takeUntil;
//# sourceMappingURL=takeUntil.js.map