"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.takeWhile = void 0;
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function takeWhile(predicate, inclusive) {
    if (inclusive === void 0) { inclusive = false; }
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var index = 0;
            var operatorSubscriber = (0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    if (predicate(value, index++)) {
                        destination.next(value);
                    }
                    else {
                        operatorSubscriber.unsubscribe();
                        if (inclusive) {
                            destination.next(value);
                        }
                        destination.complete();
                    }
                },
            });
            source.subscribe(operatorSubscriber);
        });
    };
}
exports.takeWhile = takeWhile;
//# sourceMappingURL=takeWhile.js.map