"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.throwIfEmpty = void 0;
var EmptyError_1 = require("../util/EmptyError");
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function throwIfEmpty(errorFactory) {
    if (errorFactory === void 0) { errorFactory = defaultErrorFactory; }
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var hasValue = false;
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    hasValue = true;
                    destination.next(value);
                },
                complete: function () { return (hasValue ? destination.complete() : destination.error(errorFactory())); },
            }));
        });
    };
}
exports.throwIfEmpty = throwIfEmpty;
function defaultErrorFactory() {
    return new EmptyError_1.EmptyError();
}
//# sourceMappingURL=throwIfEmpty.js.map