"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimeInterval = exports.timeInterval = void 0;
var async_1 = require("../scheduler/async");
var Observable_1 = require("../Observable");
var Subscriber_1 = require("../Subscriber");
function timeInterval(scheduler) {
    if (scheduler === void 0) { scheduler = async_1.asyncScheduler; }
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var last = scheduler.now();
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    var now = scheduler.now();
                    var interval = now - last;
                    last = now;
                    destination.next(new TimeInterval(value, interval));
                },
            }));
        });
    };
}
exports.timeInterval = timeInterval;
var TimeInterval = (function () {
    function TimeInterval(value, interval) {
        this.value = value;
        this.interval = interval;
    }
    return TimeInterval;
}());
exports.TimeInterval = TimeInterval;
//# sourceMappingURL=timeInterval.js.map