"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.windowToggle = void 0;
var Observable_1 = require("../Observable");
var Subject_1 = require("../Subject");
var Subscription_1 = require("../Subscription");
var from_1 = require("../observable/from");
var Subscriber_1 = require("../Subscriber");
var noop_1 = require("../util/noop");
var arrRemove_1 = require("../util/arrRemove");
function windowToggle(openings, closingSelector) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var windows = [];
            var handleError = function (err) {
                while (0 < windows.length) {
                    windows.shift().error(err);
                }
                destination.error(err);
            };
            (0, from_1.from)(openings).subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (openValue) {
                    var window = new Subject_1.Subject();
                    windows.push(window);
                    var closingSubscription = new Subscription_1.Subscription();
                    var closeWindow = function () {
                        (0, arrRemove_1.arrRemove)(windows, window);
                        window.complete();
                        closingSubscription.unsubscribe();
                    };
                    var closingNotifier;
                    try {
                        closingNotifier = (0, from_1.from)(closingSelector(openValue));
                    }
                    catch (err) {
                        handleError(err);
                        return;
                    }
                    destination.next(window);
                    closingSubscription.add(closingNotifier.subscribe((0, Subscriber_1.operate)({
                        destination: destination,
                        next: closeWindow,
                        error: handleError,
                        complete: noop_1.noop,
                    })));
                },
                complete: noop_1.noop,
            }));
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) {
                    var e_1, _a;
                    var windowsCopy = windows.slice();
                    try {
                        for (var windowsCopy_1 = __values(windowsCopy), windowsCopy_1_1 = windowsCopy_1.next(); !windowsCopy_1_1.done; windowsCopy_1_1 = windowsCopy_1.next()) {
                            var window_1 = windowsCopy_1_1.value;
                            window_1.next(value);
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (windowsCopy_1_1 && !windowsCopy_1_1.done && (_a = windowsCopy_1.return)) _a.call(windowsCopy_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                },
                error: handleError,
                complete: function () {
                    while (0 < windows.length) {
                        windows.shift().complete();
                    }
                    destination.complete();
                },
                finalize: function () {
                    while (0 < windows.length) {
                        windows.shift().unsubscribe();
                    }
                },
            }));
        });
    };
}
exports.windowToggle = windowToggle;
//# sourceMappingURL=windowToggle.js.map