"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.windowWhen = void 0;
var Subscriber_1 = require("../Subscriber");
var Observable_1 = require("../Observable");
var Subject_1 = require("../Subject");
var from_1 = require("../observable/from");
var noop_1 = require("../util/noop");
function windowWhen(closingSelector) {
    return function (source) {
        return new Observable_1.Observable(function (destination) {
            var window;
            var closingSubscriber;
            var handleError = function (err) {
                window.error(err);
                destination.error(err);
            };
            var openWindow = function () {
                closingSubscriber === null || closingSubscriber === void 0 ? void 0 : closingSubscriber.unsubscribe();
                window === null || window === void 0 ? void 0 : window.complete();
                window = new Subject_1.Subject();
                destination.next(window.asObservable());
                var closingNotifier;
                try {
                    closingNotifier = (0, from_1.from)(closingSelector());
                }
                catch (err) {
                    handleError(err);
                    return;
                }
                closingNotifier.subscribe((closingSubscriber = (0, Subscriber_1.operate)({
                    destination: destination,
                    next: openWindow,
                    error: handleError,
                    complete: noop_1.noop,
                })));
            };
            openWindow();
            source.subscribe((0, Subscriber_1.operate)({
                destination: destination,
                next: function (value) { return window.next(value); },
                error: handleError,
                complete: function () {
                    window.complete();
                    destination.complete();
                },
                finalize: function () {
                    closingSubscriber === null || closingSubscriber === void 0 ? void 0 : closingSubscriber.unsubscribe();
                    window = null;
                },
            }));
        });
    };
}
exports.windowWhen = windowWhen;
//# sourceMappingURL=windowWhen.js.map